Template and multilevel nesting in EJ2 JavaScript Context menu

04 Sep 202613 minutes to read

Item template

The itemTemplate property in the ContextMenu component allows you to define custom templates for displaying menu items within the context menu. This feature is especially useful when you want to customize the appearance or layout of the menu items beyond the default text-based list.

ej.base.enableRipple(true);

var menuItems = [
    {
        answerType: 'Selection',
        description: "Choose from options",
        iconCss: 'e-icons e-list-unordered'
    },
    {
        answerType: 'Yes / No',
        description: "Select Yes or No",
        iconCss: 'e-icons e-check-box'
    },
    {
        answerType: 'Text',
        description: "Type own answer",
        iconCss: 'e-icons e-caption',
        items: [
            {
                answerType: 'Single line',
                description: "Type answer in a single line",
                iconCss: 'e-icons e-text-form'
            },
            {
                answerType: 'Multiple line',
                description: "Type answer in multiple line",
                iconCss: 'e-icons e-text-wrap'
            }
        ]
    },
    {
        answerType: 'None',
        iconCss: 'e-icons e-mouse-pointer',
        description: "No answer required"
    }
];

var menuOptions = {
    target: '#contextmenutarget',
    items: menuItems,
    itemTemplate: "#cmenuTemplate",
    beforeOpen: function (args) {
        if (args.element.classList.contains('e-ul')) {
            args.element.classList.add('e-contextMenu-template');
        }
    }
};

var menuObj = new ej.navigations.ContextMenu(menuOptions, '#contextmenu');

if (ej.base.Browser.isDevice) {
    ej.base.select('#contextmenutarget').textContent = 'Right-click or touch and hold to open the Context Menu and select the answer type';
    menuObj.animationSettings.effect = 'ZoomIn';
} else {
    ej.base.select('#contextmenutarget').textContent = 'Right click/Touch hold to open the Context Menu and select the answer type';
    menuObj.animationSettings.effect = 'SlideDown';
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-buttons/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-lists/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-inputs/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">

    <!--style reference from app-->
    <link href="styles.css" rel="stylesheet">

    <!--system js reference and configuration-->
    <script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div class="control-section" id="container">
        <div class="contextmenu-control">
            <div id='contextmenutarget'></div>
            <ul id='contextmenu' class="e-contextMenu-template"></ul>
            <script id="cmenuTemplate" type="text/x-template">
                <div class="menu-wrapper">
                    <span class="${iconCss} icon-right"></span>
                    <div class="text-content">
                        <span class="text">${answerType}</span>
                        <span class="description">${description}</span>
                    </div>
                </div>
            </script>
        </div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Customize the specific menu items

ContextMenu items can be customized using the beforeItemRender event. The item render event triggers while each menu item is being rendered, and its event arguments are used to identify the menu item and customize it based on your requirement. In the following sample, each menu item is rendered with the associated keyboard shortcut for the specified action. Here, the keycode is specified for Save as, View page source, and Inspect in the right-side corner of the menu items by adding a span element in the beforeItemRender event.

ej.base.enableRipple(true);

var menuItems = [
    {
        text: 'Save as...'
    },
    {
        text: 'View page source'
    },
    {
        text: 'Inspect'
    }];
var menuOptions = {
        target: '#target',
        items: menuItems,
        beforeItemRender: beforeItemRender
    };

var menuObj = new ej.navigations.ContextMenu(menuOptions, '#contextmenu');

function beforeItemRender(args) {
    var shortCutSpan = ej.base.createElement('span');
    var text = args.item.text;
    var shortCutText = text === 'Save as...' ? 'Ctrl + S' : (text === 'View page source' ? 'Ctrl + U' : 'Ctrl + Shift + I');
    shortCutSpan.textContent = shortCutText;
    args.element.appendChild(shortCutSpan);
    shortCutSpan.setAttribute('class','shortcut');
}
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-buttons/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-lists/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-inputs/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">

    <!--style reference from app-->
    <link href="styles.css" rel="stylesheet">

    <!--system js reference and configuration-->
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <!--target element-->
        <div id="target">Right click / Touch hold to open the ContextMenu</div>
        <!--element which is going to render-->
        <ul id="contextmenu"></ul>
    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

To create the span element, use the createElement utility function from ej2-base.

Multilevel nesting

The ContextMenu supports multi-level nesting. It can be achieved by mapping the items property inside the parent’s items array. In the sample below, three-level nesting of the ContextMenu is provided.

<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-buttons/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-lists/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-inputs/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">

    <!--style reference from app-->
    <link href="styles.css" rel="stylesheet">

    <!--system js reference and configuration-->
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <!--target element-->
        <div id="target">Right click / Touch hold to open the ContextMenu</div>
        <!--element which is going to render-->
        <ul id="contextmenu"></ul>
    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

To open sub menu items only on click, set the showItemOnClick property to true.

See Also

Template and Multilevel Nesting in Vue Context Menu

03 Sep 202624 minutes to read

Item template

The itemTemplate property in the ContextMenu component allows you to define custom templates for displaying menu items within the context menu. This feature is particularly useful when you want to customize the appearance or layout of the menu items beyond the default text-based list.

<template>
    <div class="control-section">
        <div class="contextmenu-control">
            <div id='contextmenutarget'></div>
            <ejs-contextmenu cssClass="e-contextMenu-template" id="contextmenu" ref="contextMenu"
                target="#contextmenutarget" :items="data" :itemTemplate="'itemTemplate'" :beforeOpen="addtemplateClass">
                <template v-slot:itemTemplate="{ data }">
                    <div class="menu-wrapper">
                        <span :class="`${data.iconCss} icon-right`"></span>
                        <div class="text-content">
                            <span class="text"></span>
                            <span class="description"></span>
                        </div>
                    </div>
                </template>
            </ejs-contextmenu>
        </div>
    </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { ContextMenuComponent as EjsContextmenu } from "@syncfusion/ej2-vue-navigations";

const data = ref([
    {
        answerType: 'Selection',
        description: "Choose from options",
        iconCss: 'e-icons e-list-unordered'
    },
    {
        answerType: 'Yes / No',
        description: "Select Yes or No",
        iconCss: 'e-icons e-check-box',
    },
    {
        answerType: 'Text',
        description: "Type own answer",
        iconCss: 'e-icons e-caption',
        items: [
            {
                answerType: 'Single line',
                description: "Type answer in a single line",
                iconCss: 'e-icons e-text-form'
            },
            {
                answerType: 'Multiple line',
                description: "Type answer in multiple line",
                iconCss: 'e-icons e-text-wrap',
            }
        ]
    },
    {
        answerType: 'None',
        iconCss: 'e-icons e-mouse-pointer',
        description: "No answer required"
    }
]);

const addtemplateClass = (args) => {
    if (args.element.classList.contains('e-ul')) {
        args.element.classList.add('e-contextMenu-template');
    }
};

onMounted(() => {
    const menuObj = ref('contextMenu').value.ej2Instances;
    if (window.browserDetails.isDevice) {
        document.getElementById("contextmenutarget").textContent =
            "Touch hold to open the Context Menu and select the answer type";
        menuObj.animationSettings.effect = "ZoomIn";
    } else {
        document.getElementById("contextmenutarget").textContent =
            "Right click/Touch hold to open the Context Menu and select the answer type";
        menuObj.animationSettings.effect = "SlideDown";
    }
});
</script>

<style>
/* Import Syncfusion styles */
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

/* Local styles */
#target {
    border: 1px dashed;
    height: 150px;
    padding: 10px;
    position: relative;
    text-align: justify;
    color: gray;
    user-select: none;
}

.e-contextMenu-template .menu-wrapper {
    display: flex;
    align-items: center;
    padding: 2px;
}

.e-contextMenu-template .menu-wrapper .text-content {
    display: flex;
    flex-direction: column;
}

.e-contextMenu-template .menu-wrapper .text {
    font-weight: 600;
}

.e-contextMenu-template .menu-wrapper .description {
    font-size: 0.8em;
}

.e-contextMenu-template .menu-wrapper .icon-right {
    padding: 8px 8px 8px 0px;
    font-size: 1.5em;
}

.e-contextMenu-template .e-caret {
    margin-top: -34px !important;
}

.e-contextMenu-template .e-menu-item {
    height: auto !important;
    line-height: unset !important;
}

.contextmenu-control {
    margin: 5% 25%;
    width: auto;
    -webkit-touch-callout: none;
    /* iOS Safari */
    -webkit-user-select: none;
    /* Safari */
}

#contextmenutarget {
    border: 1px dashed;
    height: 250px;
    padding: 10px;
    position: relative;
    text-align: center;
    font-size: 14px;
    line-height: 17px;
    justify-content: center;
    display: flex;
    align-items: center;
}

@media only screen and (max-width: 700px) {
    .contextmenu-control {
        margin: 5% 10%;
        width: auto;
    }

    #contextmenutarget {
        line-height: 19;
        font-size: 12px;
    }
}
</style>
<template>
    <div class="control-section">
        <div class="contextmenu-control">
            <div id="contextmenutarget"></div>
            <ejs-contextmenu cssClass="e-contextMenu-template" id="contextmenu" ref="contextMenu"
                target="#contextmenutarget" :items="data" :itemTemplate="'itemTemplate'" :beforeOpen="addTemplateClass">
                <template v-slot:itemTemplate="{ data }">
                    <div class="menu-wrapper">
                        <span :class="`${data.iconCss} icon-right`"></span>
                        <div class="text-content">
                            <span class="text"></span>
                            <span class="description"></span>
                        </div>
                    </div>
                </template>
            </ejs-contextmenu>
        </div>
        <div id="action-description">
            <p>This sample demonstrates the template support functionalities of the ContextMenu. You can customize the
                menu
                items using templates to enhance flexibility and integrate custom content.</p>
        </div>
    </div>
</template>

<script>
import { ContextMenuComponent } from "@syncfusion/ej2-vue-navigations";

export default {
    components: {
        'ejs-contextmenu': ContextMenuComponent
    },
    data() {
        return {
            data: [
                {
                    answerType: 'Selection',
                    description: "Choose from options",
                    iconCss: 'e-icons e-list-unordered'
                },
                {
                    answerType: 'Yes / No',
                    description: "Select Yes or No",
                    iconCss: 'e-icons e-check-box',
                },
                {
                    answerType: 'Text',
                    description: "Type your own answer",
                    iconCss: 'e-icons e-caption',
                    items: [
                        {
                            answerType: 'Single line',
                            description: "Type answer in a single line",
                            iconCss: 'e-icons e-text-form'
                        },
                        {
                            answerType: 'Multiple line',
                            description: "Type answer in multiple lines",
                            iconCss: 'e-icons e-text-wrap',
                        }
                    ]
                },
                {
                    answerType: 'None',
                    iconCss: 'e-icons e-mouse-pointer',
                    description: "No answer required"
                },
            ]
        };
    },
    methods: {
        addTemplateClass(args) {
            if (args.element.classList.contains('e-ul')) {
                args.element.classList.add('e-contextMenu-template');
            }
        }
    },
    mounted() {
        const menuObj = this.$refs.contextMenu.ej2Instances;
        const targetElement = document.getElementById("contextmenutarget");
        if (window.navigator.userAgent.match(/(iPhone|iPod|iPad|Android)/)) {
            targetElement.textContent = "Touch hold to open the Context Menu and select the answer type";
            menuObj.animationSettings.effect = "ZoomIn";
        } else {
            targetElement.textContent = "Right click/Touch hold to open the Context Menu and select the answer type";
            menuObj.animationSettings.effect = "SlideDown";
        }
    }
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";

.contextmenu-control {
    margin: 5% 25%;
    width: auto;
    -webkit-touch-callout: none;
    -webkit-user-select: none;
}

#contextmenutarget {
    border: 1px dashed;
    height: 250px;
    padding: 10px;
    position: relative;
    text-align: center;
    font-size: 14px;
    line-height: 17px;
    justify-content: center;
    display: flex;
    align-items: center;
}

.e-contextMenu-template .menu-wrapper {
    display: flex;
    align-items: center;
    padding: 2px;
}

.e-contextMenu-template .menu-wrapper .text-content {
    display: flex;
    flex-direction: column;
}

.e-contextMenu-template .menu-wrapper .text {
    font-weight: 600;
}

.e-contextMenu-template .menu-wrapper .description {
    font-size: 0.8em;
}

.e-contextMenu-template .menu-wrapper .icon-right {
    padding: 8px 8px 8px 0px;
    font-size: 1.5em;
}

.e-contextMenu-template .e-caret {
    margin-top: -34px !important;
}

.e-contextMenu-template .e-menu-item {
    height: auto !important;
    line-height: unset !important;
}

@media only screen and (max-width: 700px) {
    .contextmenu-control {
        margin: 5% 10%;
        width: auto;
    }

    #contextmenutarget {
        line-height: 19px;
        font-size: 12px;
    }
}
</style>

Customize the specific menu items

The ContextMenu items can be customized by using the beforeItemRender event. The item render event triggers while rendering each menu item. The event argument will be used to identify the menu item and customize it based on the requirement. In the following sample, the menu item is rendered with key code for specified action in ContextMenu using the template. Here, the key code is specified for Save as, View page source, and Inspect in the right side corner of the menu items by adding a span element in the beforeItemRender event.

<template>
  <div>
    <div id="target">Right click / Touch hold to open the ContextMenu</div>
    <ejs-contextmenu target='#target' :items='menuItems' :beforeItemRender="onBeforeItemRender"></ejs-contextmenu>
  </div>
</template>

<script setup>

import { ContextMenuComponent as EjsContextmenu } from "@syncfusion/ej2-vue-navigations";
import { enableRipple, createElement } from '@syncfusion/ej2-base';

enableRipple(true);

const menuItems = [
  {
    text: 'Save as...'
  },
  {
    text: 'View page source'
  },
  {
    text: 'Inspect'
  }];
const onBeforeItemRender = (args) => {
  var shortCutSpan = createElement('span');
  var text = args.item.text;
  var shortCutText = text === 'Save as...' ? 'Ctrl + S' : (text === 'View page source' ?
    'Ctrl + U' : 'Ctrl + Shift + I');
  shortCutSpan.textContent = shortCutText;
  args.element.appendChild(shortCutSpan);
  shortCutSpan.setAttribute('class', 'shortcut');
};

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

#target {
  border: 1px dashed;
  height: 150px;
  padding: 10px;
  position: relative;
  text-align: justify;
  color: gray;
  user-select: none;
}

.shortcut {
  float: right;
  font-size: 10px;
  opacity: 0.5;
  padding-left: 50px;
}
</style>
<template>
    <div>
        <div id="target">Right click / Touch hold to open the ContextMenu</div>
        <ejs-contextmenu target='#target' :items='menuItems' :beforeItemRender="onBeforeItemRender"></ejs-contextmenu>
    </div>
</template>

<script>

import { ContextMenuComponent } from "@syncfusion/ej2-vue-navigations";
import { enableRipple, createElement } from '@syncfusion/ej2-base';

enableRipple(true);

export default {
    name: "App",
    components: {
        "ejs-contextmenu": ContextMenuComponent
    },
    data() {
        return {
            menuItems: [
                {
                    text: 'Save as...'
                },
                {
                    text: 'View page source'
                },
                {
                    text: 'Inspect'
                }]
        };
    },
    methods: {
        onBeforeItemRender: function (args) {
            var shortCutSpan = createElement('span');
            var text = args.item.text;
            var shortCutText = text === 'Save as...' ? 'Ctrl + S' : (text === 'View page source' ?
                'Ctrl + U' : 'Ctrl + Shift + I');
            shortCutSpan.textContent = shortCutText;
            args.element.appendChild(shortCutSpan);
            shortCutSpan.setAttribute('class', 'shortcut');
        }
    }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

#target {
    border: 1px dashed;
    height: 150px;
    padding: 10px;
    position: relative;
    text-align: justify;
    color: gray;
    user-select: none;
}

.shortcut {
    float: right;
    font-size: 10px;
    opacity: 0.5;
    padding-left: 50px;
}
</style>

To create a span element, the createElement utility function is used from ej2-base.

Multilevel nesting

Multilevel nesting is supported in ContextMenu. It can be achieved by mapping the items property inside the parent menuItems. In the following sample, three-level nesting of ContextMenu is provided.

<template>
    <div>
        <div id="target">Right click / Touch hold to open the ContextMenu</div>
        <ejs-contextmenu target='#target' :items='menuItems'></ejs-contextmenu>
    </div>
</template>

<script setup>

import { ContextMenuComponent as EjsContextmenu } from "@syncfusion/ej2-vue-navigations";
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

const menuItems = [
    {
        text: 'Show All Bookmarks',
    },
    {
        text: 'Bookmarks Toolbar',
        items: [
            {
                text: 'Most Visited',
                items: [
                    {
                        text: 'Google',
                    },
                    {
                        text: 'Gmail'
                    }]
            },
            {
                text: 'Recently Added'
            }
        ]
    }];

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

#target {
    border: 1px dashed;
    height: 150px;
    padding: 10px;
    position: relative;
    text-align: justify;
    color: gray;
    user-select: none;
}
</style>
<template>
    <div>
        <div id="target">Right click / Touch hold to open the ContextMenu</div>
        <ejs-contextmenu target='#target' :items='menuItems'></ejs-contextmenu>
    </div>
</template>

<script>

import { ContextMenuComponent } from "@syncfusion/ej2-vue-navigations";
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

export default {
    name: "App",
    components: {
        "ejs-contextmenu": ContextMenuComponent
    },
    data() {
        return {
            menuItems: [
                {
                    text: 'Show All Bookmarks',
                },
                {
                    text: 'Bookmarks Toolbar',
                    items: [
                        {
                            text: 'Most Visited',
                            items: [
                                {
                                    text: 'Google',
                                },
                                {
                                    text: 'Gmail'
                                }]
                        },
                        {
                            text: 'Recently Added'
                        }
                    ]
                }]
        };
    }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

#target {
    border: 1px dashed;
    height: 150px;
    padding: 10px;
    position: relative;
    text-align: justify;
    color: gray;
    user-select: none;
}
</style>

Templates in React Context Menu

04 Sep 202624 minutes to read

Item template

The itemTemplate property in the Context Menu component allows you to define custom templates for displaying menu items. This feature enables you to customize the appearance, layout, and content of menu items beyond the default text-based display. Use item templates when you need to include icons, formatted text, additional metadata, or complex HTML structures within menu items.

import { enableRipple, Browser } from '@syncfusion/ej2-base';
import { ContextMenuComponent, MenuEventArgs, MenuItemModel } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';

enableRipple(true);

function App() {
    const template = "<div class='menu-wrapper'><span class='${iconCss} icon-right'></span><div class='text-content'><span class='text'>${answerType}</span><span class='description'>${description}</span></div></div>";
    let content = Browser.isDevice ? 'Right-click or touch and hold to open the Context Menu and select the answer type' : 'Right click/Touch hold to open the Context Menu and select the answer type';

    // ContextMenu items definition
    const menuItems = [
        {
            answerType: 'Selection',
            description: "Choose from options",
            iconCss: 'e-icons e-list-unordered'
        },
        {
            answerType: 'Yes / No',
            description: "Select Yes or No",
            iconCss: 'e-icons e-check-box',
        },
        {
            answerType: 'Text',
            description: "Type own answer",
            iconCss: 'e-icons e-caption',
            items: [
                {
                    answerType: 'Single line',
                    description: "Type answer in a single line",
                    iconCss: 'e-icons e-text-form'
                },
                {
                    answerType: 'Multiple line',
                    description: "Type answer in multiple line",
                    iconCss: 'e-icons e-text-wrap'
                }
            ]
        },
        {
            answerType: 'None',
            iconCss: 'e-icons e-mouse-pointer',
            description: "No answer required"
        },
    ];

    const addTemplateClass = (args) => {
        if (args.element.classList.contains('e-ul')) {
            args.element.classList.add('e-contextMenu-template');
        }
    };

    return (
        <div className='control-pane'>
            <div className='control-section'>
                <div className='contextmenu-section'>
                    <div id='contextmenu-control'>
                        <div id="contextmenutarget">{content}</div>
                        <ContextMenuComponent
                            className="e-contextMenu-template"
                            target='#contextmenutarget'
                            items={menuItems}
                            itemTemplate={template}
                            beforeOpen={addTemplateClass}
                        />
                    </div>
                </div>
            </div>
        </div>
    );
}
export default App;
ReactDom.render(<App />, document.getElementById('element'));
import { enableRipple, Browser } from '@syncfusion/ej2-base';
import { ContextMenuComponent, MenuEventArgs, MenuItemModel } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';

enableRipple(true);

function App() {
    const template: string = "<div class='menu-wrapper'><span class='${iconCss} icon-right'></span><div class='text-content'><span class='text'>${answerType}</span><span class='description'>${description}</span></div></div>";
    let content: string = Browser.isDevice ? 'Right-click or touch and hold to open the Context Menu and select the answer type' : 'Right click/Touch hold to open the Context Menu and select the answer type';

    // ContextMenu items definition
    const menuItems: any = [
        {
            answerType: 'Selection',
            description: "Choose from options",
            iconCss: 'e-icons e-list-unordered'
        },
        {
            answerType: 'Yes / No',
            description: "Select Yes or No",
            iconCss: 'e-icons e-check-box',
        },
        {
            answerType: 'Text',
            description: "Type own answer",
            iconCss: 'e-icons e-caption',
            items: [
                {
                    answerType: 'Single line',
                    description: "Type answer in a single line",
                    iconCss: 'e-icons e-text-form'
                },
                {
                    answerType: 'Multiple line',
                    description: "Type answer in multiple line",
                    iconCss: 'e-icons e-text-wrap'
                }
            ]
        },
        {
            answerType: 'None',
            iconCss: 'e-icons e-mouse-pointer',
            description: "No answer required"
        },
    ];

    const addTemplateClass = (args: MenuEventArgs) => {
        if (args.element.classList.contains('e-ul')) {
            args.element.classList.add('e-contextMenu-template');
        }
    };

    return (
        <div className='control-pane'>
            <div className='control-section'>
                <div className='contextmenu-section'>
                    <div id='contextmenu-control'>
                        <div id="contextmenutarget">{content}</div>
                        <ContextMenuComponent
                            className="e-contextMenu-template"
                            target='#contextmenutarget'
                            items={menuItems}
                            itemTemplate={template}
                            beforeOpen={addTemplateClass}
                        />
                    </div>
                </div>
            </div>
        </div>
    );
}

export default App;
ReactDom.render(<App />, document.getElementById('element'));

Customize specific menu items

The React Context Menu items can be customized using the beforeItemRender event. This event fires during rendering of each menu item. The handler receives a MenuEventArgs argument exposing:

Member Description
element The DOM node rendered for the menu item.
item The data object (MenuItemModel) for the menu item, used to read fields such as text, iconCss, and url.

The following example reads args.item.text to choose a keyboard shortcut and appends a <span> element to args.element during the rendering process. The createElement utility from @syncfusion/ej2-base is used to create the span element.

import { createElement, enableRipple } from '@syncfusion/ej2-base';
import { ContextMenuComponent } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';
enableRipple(true);
function App() {
    let menuItems = [
        {
            text: 'Save as...'
        },
        {
            text: 'View page source'
        },
        {
            text: 'Inspect'
        }
    ];
    function itemBeforeEvent(args) {
        const shortCutSpan = createElement('span');
        const text = args.item.text;
        const shortCutText = text === 'Save as...' ? 'Ctrl + S' : (text === 'View page source' ? 'Ctrl + U' : 'Ctrl + Shift + I');
        shortCutSpan.textContent = shortCutText;
        args.element.appendChild(shortCutSpan);
        shortCutSpan.setAttribute('class', 'shortcut');
    }
    return (<div class="container">
              <div id='target'>Right click / Touch hold to open the ContextMenu</div>
              <ContextMenuComponent id='contextmenu' target='#target' items={menuItems} beforeItemRender={itemBeforeEvent}/>
           </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('element'));
import { createElement, enableRipple } from '@syncfusion/ej2-base';
import { ContextMenuComponent, MenuEventArgs, MenuItemModel } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';

enableRipple(true);

function App() {
  let menuItems: MenuItemModel[] = [
    {
        text: 'Save as...'
    },
    {
        text: 'View page source'
    },
    {
        text: 'Inspect'
    }];
    function itemBeforeEvent(args: MenuEventArgs) {
        const shortCutSpan = createElement('span');
        const text = args.item.text;
        const shortCutText = text === 'Save as...' ? 'Ctrl + S' : (text === 'View page source' ? 'Ctrl + U' : 'Ctrl + Shift + I');
        shortCutSpan.textContent = shortCutText;
        args.element.appendChild(shortCutSpan);
        shortCutSpan.setAttribute('class','shortcut');
    }

    return (
            <div class="container">
              <div id='target'>Right click / Touch hold to open the ContextMenu</div>
              <ContextMenuComponent id='contextmenu' target='#target'
              items={menuItems} beforeItemRender={itemBeforeEvent}/>
           </div>
        );
}
export default App;
ReactDom.render(<App />,document.getElementById('element'));

Multi-level nesting

The React Context Menu component supports multiple levels of nesting for creating hierarchical menu structures. Achieve this by mapping the items field of each parent menu item (see MenuItemModel.items) to an array of child MenuItemModel objects. By default, submenu items open on hover; the menu is not limited to a fixed nesting depth, but for usability we recommend keeping nesting to three or four levels. The following example demonstrates a three-level nested React Context Menu structure.

import * as React from 'react';
import * as ReactDom from 'react-dom';
import { ContextMenuComponent } from '@syncfusion/ej2-react-navigations';
import { enableRipple } from '@syncfusion/ej2-base';
enableRipple(true);
function App() {
    let menuItems = [
        {
            text: 'Show All Bookmarks'
        },
        {
            text: 'Bookmarks Toolbar',
            items: [
                {
                    text: 'Most Visited',
                    items: [
                        {
                            text: 'Google'
                        },
                        {
                            text: 'Gmail'
                        }
                    ]
                },
                {
                    text: 'Recently Added'
                }
            ]
        }
    ];
    return (<div class="container">
                <div id='target'>Right click / Touch hold to open the ContextMenu</div>
                <ContextMenuComponent id='contextmenu' target='#target' items={menuItems}> </ContextMenuComponent>
            </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('element'));
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { ContextMenuComponent, MenuItemModel } from '@syncfusion/ej2-react-navigations';
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

function App() {
    let menuItems: MenuItemModel[] = [
    {
        text: 'Show All Bookmarks'
    },
    {
        text: 'Bookmarks Toolbar',
        items: [
            {
                text: 'Most Visited',
                items: [
                    {
                        text: 'Google'
                    },
                    {
                        text: 'Gmail'
                    }
                ]
            },
            {
                text: 'Recently Added'
            }
        ]
    }];

    return (
            <div class="container">
                <div id='target'>Right click / Touch hold to open the ContextMenu</div>
                <ContextMenuComponent id='contextmenu' target='#target'
                items={menuItems}> </ContextMenuComponent>
            </div>
        );
}
export default App;
ReactDom.render(<App />,document.getElementById('element'));

By default, submenu items open when the parent item is hovered. To open submenu items only on click, set the showItemOnClick property to true.

See also